Package org.apache.sis.metadata.iso.identification

# Class DefaultBrowseGraphic

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultBrowseGraphic

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `BrowseGraphic`

public class DefaultBrowseGraphic extends ISOMetadata implements BrowseGraphic
Graphic that provides an illustration of the dataset (should include a legend for the graphic). The following property is mandatory in a well-formed metadata according ISO 19115:
`MD_BrowseGraphic` `└─fileName…………` Name of the file that contains a graphic that provides an illustration of the dataset.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

Defined in the `sis-metadata` module

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultBrowseGraphic()`
  Constructs an initially empty browse graphic.
  `DefaultBrowseGraphic(URI fileName)`
  Creates a browse graphics initialized to the specified URI.
  `DefaultBrowseGraphic(BrowseGraphic object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultBrowseGraphic`
  `castOrCopy(BrowseGraphic object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `InternationalString`
  `getFileDescription()`
  Returns the text description of the illustration.
  `URI`
  `getFileName()`
  Returns the name of the file that contains a graphic that provides an illustration of the dataset.
  `String`
  `getFileType()`
  Format in which the illustration is encoded.
  `Collection<Constraints>`
  `getImageConstraints()`
  Returns the restrictions on access and / or use of browse graphic.
  `Collection<OnlineResource>`
  `getLinkages()`
  Return the links to browse graphic.
  `void`
  `setFileDescription(InternationalString newValue)`
  Sets the text description of the illustration.
  `void`
  `setFileName(URI newValue)`
  Sets the name of the file that contains a graphic that provides an illustration of the dataset.
  `void`
  `setFileType(String newValue)`
  Sets the format in which the illustration is encoded.
  `void`
  `setImageConstraints(Collection<? extends Constraints> newValues)`
  Sets the restrictions on access and / or use of browse graphic.
  `void`
  `setLinkages(Collection<? extends OnlineResource> newValues)`
  Sets the links to browse graphic.

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DefaultBrowseGraphic

    public DefaultBrowseGraphic()
    Constructs an initially empty browse graphic.

  - ### DefaultBrowseGraphic

    public DefaultBrowseGraphic(URI fileName)
    Creates a browse graphics initialized to the specified URI.
    Parameters:
      `fileName` - the name of the file that contains a graphic.

  - ### DefaultBrowseGraphic

    public DefaultBrowseGraphic(BrowseGraphic object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(BrowseGraphic)`

- ## Method Details

  - ### castOrCopy

    public static DefaultBrowseGraphic castOrCopy(BrowseGraphic object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultBrowseGraphic`, then it is returned unchanged.
    - Otherwise a new `DefaultBrowseGraphic` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getFileName

    public URI getFileName()
    Returns the name of the file that contains a graphic that provides an illustration of the dataset.
    Specified by:
      `getFileName` in interface `BrowseGraphic`
    Returns:
      file that contains a graphic that provides an illustration of the dataset, or `null`.

  - ### setFileName

    public void setFileName(URI newValue)
    Sets the name of the file that contains a graphic that provides an illustration of the dataset.
    Parameters:
      `newValue` - the new filename.

  - ### getFileDescription

    public InternationalString getFileDescription()
    Returns the text description of the illustration.
    Specified by:
      `getFileDescription` in interface `BrowseGraphic`
    Returns:
      text description of the illustration, or `null`.

  - ### setFileDescription

    public void setFileDescription(InternationalString newValue)
    Sets the text description of the illustration.
    Parameters:
      `newValue` - the new file description.

  - ### getFileType

    public String getFileType()
    Format in which the illustration is encoded.
    Example: CGM, EPS, GIF, JPEG, PBM, PS, TIFF, XWD.
    Specified by:
      `getFileType` in interface `BrowseGraphic`
    Returns:
      format in which the illustration is encoded, or `null`.

  - ### setFileType

    public void setFileType(String newValue)
    Sets the format in which the illustration is encoded. Raster formats are encouraged to use one of the names returned by `ImageIO​.getReaderFormatNames()`.
    Parameters:
      `newValue` - the new file type.

  - ### getImageConstraints

    @UML(identifier="imageContraints", obligation=OPTIONAL, specification=ISO_19115) public Collection<Constraints> getImageConstraints()
    Returns the restrictions on access and / or use of browse graphic.
    Returns:
      restrictions on access and / or use of browse graphic.
    Since:
      0.5

  - ### setImageConstraints

    public void setImageConstraints(Collection<? extends Constraints> newValues)
    Sets the restrictions on access and / or use of browse graphic.
    Parameters:
      `newValues` - the new restrictions on access and / or use of browse graphic.
    Since:
      0.5

  - ### getLinkages

    @UML(identifier="linkage", obligation=OPTIONAL, specification=ISO_19115) public Collection<OnlineResource> getLinkages()
    Return the links to browse graphic.
    Returns:
      the links to browse graphic.
    Since:
      0.5

  - ### setLinkages

    public void setLinkages(Collection<? extends OnlineResource> newValues)
    Sets the links to browse graphic.
    Parameters:
      `newValues` - the new links to browse graphic.
    Since:
      0.5